package dev.pfaff.log4truth.compat.slf4j;

import org.slf4j.ILoggerFactory;
import org.slf4j.IMarkerFactory;
import org.slf4j.helpers.BasicMDCAdapter;
import org.slf4j.helpers.BasicMarkerFactory;
import org.slf4j.spi.MDCAdapter;
import org.slf4j.spi.SLF4JServiceProvider;

public record SLF4JToL4TServiceProvider() implements SLF4JServiceProvider {
	private static final IMarkerFactory MARKER_FACTORY = new BasicMarkerFactory();
	private static final MDCAdapter MDC_ADAPTER = new BasicMDCAdapter();

	@Override
	public ILoggerFactory getLoggerFactory() {
		return SLF4JToL4TLogger::new;
	}

	@Override
	public IMarkerFactory getMarkerFactory() {
		return MARKER_FACTORY;
	}

	@Override
	public MDCAdapter getMDCAdapter() {
		return MDC_ADAPTER;
	}

	@Override
	public String getRequestedApiVersion() {
		return "2.0.0";
	}

	@Override
	public void initialize() {}
}
